/************************************************************************
 *																		*
 *	F-BASIC386pgW[ << MODULE-NAME : INOUT >>				*
 *																		*
 *				COPYRIGHT (C) FUJITSU PERSONAL COMPUTER SYSTEMS 1990	*
 *																		*
 *		(AUTHOR)	: g 	i FPS)Zp j						*
 *																		*
 *		(FUNCTION)	: I/O IN,OUT Program								*
 *					  (use loadm)										*
 *																		*
 *	(UPDATE HISTORY)													*
 *	Ver	Level	Date		Ce			Module			Name	*
 *----------------------------------------------------------------------*
 *																		*
 ************************************************************************/

extern	int	inp();
extern	int	inpw();
extern	int	outp();
extern	int	outpw();

/************************************************************************
 *																		*
 *   <<	 FUNCTION-NAME : bs_io() >>										*
 *																		*
 *	(@\\)	fb386loadmAI/Oւ̓o͂						*
 *																		*
 *	()	unsigned int io_adr	I/O address								*
 *			unsigned int mode	4bit..byte						*
 *								bit7......0:read 1:write				*
 *			unsigned char *data	f[^̓(Ԃ)			*
 *									fBXNv^						*
 *																		*
 *	(o)	߂l	0:	1:ERROR										*
 *	()	*data --> AhX(4byte) + (2byte)						*
 *																		*
 *																		*
 *	(UPDATE	HISTORY)													*
 *	Ver	Level	Date		Ce			Module			Name	*
 *----------------------------------------------------------------------*
 *	0	0.0		90/01/14	first generate						O.Y.	*
 *																		*
 ************************************************************************/
int	bs_io(io_adr,mode,data)
unsigned int	io_adr;
unsigned int	mode;
unsigned char	*data;
{
	unsigned int	bw;
	unsigned short	len;
	unsigned char	*d_adr;

	/*	error check	*/
	if(io_adr >= 0x10000)
		return(1);
	bw = mode & 0x7f;
	if(!(bw == 2 || bw == 1))
		return(1);
	d_adr = *(unsigned char	**)data;
	len = *(unsigned short *)(data+4);
	if(len != bw)
		return(1);

	/*	io read/write	*/
	switch(mode){
		case 0x01:
			*d_adr = (unsigned char)inp(io_adr);
		case 0x02:
			*(unsigned short *)d_adr = (unsigned short)inpw(io_adr);
		case 0x81:
			outp(io_adr,*d_adr);
		case 0x82:
			outpw(io_adr,*(unsigned short *)d_adr);
	}
	return(0);
}
/*  << end of source >>	 */
